/*
 	File:		FileTransferTools.h
 
 	Copyright:	 1984-1994 by Apple Computer, Inc.
 				All rights reserved.
 
 	Version:	Universal Interfaces 2.0a3  ETO #16, MPW prerelease.  Friday, November 11, 1994. 
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*/

#ifndef __FILETRANSFERTOOLS__
#define __FILETRANSFERTOOLS__


#ifndef __DIALOGS__
#include <Dialogs.h>
#endif
/*	#include <Errors.h>											*/
/*		#include <ConditionalMacros.h>							*/
/*	#include <Memory.h>											*/
/*		#include <Types.h>										*/
/*		#include <MixedMode.h>									*/
/*	#include <Windows.h>										*/
/*		#include <Quickdraw.h>									*/
/*			#include <QuickdrawText.h>							*/
/*		#include <Events.h>										*/
/*			#include <OSUtils.h>								*/
/*		#include <Controls.h>									*/
/*			#include <Menus.h>									*/
/*	#include <TextEdit.h>										*/

#ifndef __FILETRANSFERS__
#include <FileTransfers.h>
#endif
/*	#include <CTBUtilities.h>									*/
/*		#include <StandardFile.h>								*/
/*			#include <Files.h>									*/
/*		#include <AppleTalk.h>									*/
/*	#include <Connections.h>									*/
/*	#include <Terminals.h>										*/

#ifdef __cplusplus
extern "C" {
#endif

#if GENERATINGPOWERPC
#pragma options align=mac68k
#endif

#ifdef __CFM68K__
#pragma lib_export on
#endif


enum {
/* DEFs */
	fdefType					= 'fdef',
	fsetType					= 'fset',
	fvalType					= 'fval',
	flocType					= 'floc',
	fscrType					= 'fscr',
	fbndType					= 'fbnd',
	fverType					= 'vers'
};

enum {
/* control */
	ftInitMsg					= 0,
	ftDisposeMsg				= 1,
	ftSuspendMsg				= 2,
	ftResumeMsg					= 3,
	ftMenuMsg					= 4,
	ftEventMsg					= 5,
	ftActivateMsg				= 6,
	ftDeactivateMsg				= 7,
	ftGetErrorStringMsg			= 8,
	ftAbortMsg					= 52,
	ftStartMsg					= 100,
	ftExecMsg					= 102,
	ftSendMsg					= 103,
	ftReceiveMsg				= 104,
/* setup */
	ftSpreflightMsg				= 0,
	ftSsetupMsg					= 1,
	ftSitemMsg					= 2,
	ftSfilterMsg				= 3,
	ftScleanupMsg				= 4,
/* validate */
	ftValidateMsg				= 0
};

enum {
	ftDefaultMsg				= 1,
/* scripting */
	ftMgetMsg					= 0,
	ftMsetMsg					= 1,
/* localization */
	ftL2English					= 0,
	ftL2Intl					= 1
};

struct FTSetupStruct {
	DialogPtr						theDialog;					/* the dialog form the application */
	short							count;						/* first appended item */
	Ptr								theConfig;					/* the config record to setup */
	short							procID;						/* procID of the tool */
};
typedef struct FTSetupStruct FTSetupStruct;

typedef FTSetupStruct *FTSetupPtr;


#ifdef __CFM68K__
#pragma lib_export off
#endif

#if GENERATINGPOWERPC
#pragma options align=reset
#endif

#ifdef __cplusplus
}
#endif

#endif /* __FILETRANSFERTOOLS__ */
