{
 	File:		Displays.p
 
 	Copyright:	 1984-1994 by Apple Computer, Inc.
 				All rights reserved.
 
 	Version:	Universal Interfaces 2.0a3  ETO #16, MPW prerelease.  Friday, November 11, 1994. 
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT Displays;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __DISPLAYS__}
{$SETC __DISPLAYS__ := 1}

{$I+}
{$SETC DisplaysIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}


{$IFC UNDEFINED __CONDITIONALMACROS__}
{$I ConditionalMacros.p}
{$ENDC}

{$IFC UNDEFINED __COMPONENTS__}
{$I Components.p}
{$ENDC}
{	Types.p														}
{	MixedMode.p													}
{$IFC UNDEFINED __SKIP_DISPLAY_INCLUDES__ }

{$IFC UNDEFINED __APPLEEVENTS__}
{$I AppleEvents.p}
{$ENDC}
{	Errors.p													}
{	Memory.p													}
{	OSUtils.p													}
{	Events.p													}
{		Quickdraw.p												}
{			QuickdrawText.p										}
{	EPPC.p														}
{		PPCToolbox.p											}
{			AppleTalk.p											}
{		Processes.p												}
{			Files.p												}
{	Notification.p												}

{$IFC UNDEFINED __WINDOWS__}
{$I Windows.p}
{$ENDC}
{	Controls.p													}
{		Menus.p													}
{$ENDC}

{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}

CONST
{ AppleEvents Core Suite }
	kAESystemConfigNotice		= 'cnfg';
{ Core Suite types }
	kAEDisplayNotice			= 'dspl';
	kAEDisplaySummary			= 'dsum';
	keyDMConfigVersion			= 'dmcv';
	keyDMConfigFlags			= 'dmcf';
	keyDMConfigReserved			= 'dmcr';
	keyDisplayID				= 'dmid';
	keyDisplayComponent			= 'dmdc';
	keyDisplayDevice			= 'dmdd';
	keyDisplayFlags				= 'dmdf';
	keyDisplayMode				= 'dmdm';
	keyDisplayModeReserved		= 'dmmr';
	keyDisplayReserved			= 'dmdr';
	keyDisplayMirroredId		= 'dmmi';
	keyDeviceFlags				= 'dddf';
	keyDeviceDepthMode			= 'dddm';
	keyDeviceRect				= 'dddr';
	keyPixMapRect				= 'dpdr';
	keyPixMapHResolution		= 'dphr';
	keyPixMapVResolution		= 'dpvr';
	keyPixMapPixelType			= 'dppt';
	keyPixMapPixelSize			= 'dpps';
	keyPixMapCmpCount			= 'dpcc';
	keyPixMapCmpSize			= 'dpcs';
	keyPixMapAlignment			= 'dppa';
	keyPixMapResReserved		= 'dprr';
	keyPixMapReserved			= 'dppr';
	keyPixMapColorTableSeed		= 'dpct';
	keySummaryMenubar			= 'dsmb';
	keySummaryChanges			= 'dsch';
	keyDisplayOldConfig			= 'dold';
	keyDisplayNewConfig			= 'dnew';

	dmOnlyActiveDisplays		= true;
	dmAllDisplays				= false;

{ Switch Flags }
	kNoSwitchConfirmBit			= 0;							{ Flag indicating that there is no need to confirm a switch to this mode }
	kDepthNotAvailableBit		= 1;							{ Current depth not available in new mode }
	kShowModeBit				= 3;							{ Show this mode even though it requires a confirm. }
	kModeNotResizeBit			= 4;							{ Do not use this mode to resize display (for cards that mode drives a different connector). }

{	Summary Change Flags (sticky bits indicating an operation was performed)
	For example, moving a display then moving it back will still set the kMovedDisplayBit.
}
	kBeginEndConfigureBit		= 0;
	kMovedDisplayBit			= 1;
	kSetMainDisplayBit			= 2;
	kSetDisplayModeBit			= 3;
	kAddDisplayBit				= 4;
	kRemoveDisplayBit			= 5;
	kNewDisplayBit				= 6;
	kDisposeDisplayBit			= 7;
	kEnabledDisplayBit			= 8;
	kDisabledDisplayBit			= 9;
	kMirrorDisplayBit			= 10;
	kUnMirrorDisplayBit			= 11;

{ Notification Messages for extended call back routines }
	kDMNotifyInstalled			= 1;							{ At install time }
	kDMNotifyEvent				= 2;							{ Post change time }
	kDMNotifyRemoved			= 3;							{ At remove time }
	kDMNotifyPrep				= 4;							{ Pre change time }
	kDMNotifyExtendEvent		= 5;							{ Allow registrees to extend apple event before it is sent }
	kDMNotifyDependents			= 6;							{ Minor notification check without full update }
{ Notification Flags }
	kExtendedNotificationProc	= 0+(1 * (2**(16)));

{ Selectors for tablecloths }
	kTableclothInit				= 0;
	kTableclothDraw				= 1;
	kTableclothAnimate			= 2;
	kTableclothAnimateContinue	= 3;
	kTableclothClose			= 4;

	
TYPE
	TableclothMessagesType = INTEGER;

{ types for notifyType }

CONST
	kFullNotify					= 0;							{ This is the appleevent whole nine yards notify }
	kFullDependencyNotify		= 1;							{ Only sends to those who want to know about interrelated functionality (used for updating UI) }

{ DisplayID/DeviceID constants }
	kDummyDeviceID				= $0FF;							{ This is the ID of the dummy display, used when the last real display is disabled.}
	kInvalidDisplayID			= $000;							{ This is the invalid ID}
	kFirstDisplayID				= $100;

{ bits for panelListFlags }
	kAllowDuplicatesBit			= 0;

{ Constants for fidelity checks }
	kNoFidelity					= 0;
	kMinimumFidelity			= 1;
	kDefaultFidelity			= 500;							{ I'm just picking a number for Apple default panels and engines}
	kDefaultManufacturorFidelity = 1000;						{ I'm just picking a number for Manufacturor's panels and engines (overrides apple defaults)}

	kAnyPanelType				= 0;							{ Pass to DMNewEngineList for list of all panels (as opposed to specific types)}
	kAnyEngineType				= 0;							{ Pass to DMNewEngineList for list of all engines}
	kAnyDeviceType				= 0;							{ Pass to DMNewDeviceList for list of all devices}
	kAnyPortType				= 0;							{ Pass to DMNewDevicePortList for list of all devices}

{ portListFlags for DM_NewDevicePortList }
{ Should offline devices be put into the port list (such as dummy display) }
	kPLIncludeOfflineDevicesBit	= 0;

	
TYPE
	DMFidelityType = LONGINT;

	DisplayIDType = LONGINT;

	DMListType = Ptr;

	DMListIndexType = LONGINT;

	DMListEntryRec = RECORD
		itemID:					DisplayIDType;							{ DisplayID Manager}
		itemComponent:			Component;								{ Component Manager}
		itemDescription:		ComponentDescription;					{ We can always construct this if we use something beyond the compontent mgr.}
		itemClass:				ResType;								{ Class of group to put this panel (eg geometry/color/etc for panels, brightness/contrast for engines, video out/sound/etc for devices)}
		itemFidelity:			DMFidelityType;							{ How good is this item for the specified search?}
		itemFlags:				LONGINT;								{ Set to 0 (future expansion)}
		itemReserved:			ResType;								{ What kind of code does the itemReference point to  (right now - kPanelEntryTypeComponentMgr only)}
		itemFuture:				LONGINT;								{ Set to 0 (future expansion - probably an alternate code style)}
	END;
	DMListEntryPtr = ^DMListEntryRec;

	DependentNotifyRec = RECORD
		notifyType:				ResType;								{ What type was the engine that made the change (may be zero)}
		notifyClass:			ResType;								{ What class was the change (eg geometry, color etc)}
		displayID:				DisplayIDType;							{ Which device was touched (kInvalidDisplayID -> all or none)}
		notifyComponent:		ComponentInstance;						{ What engine did it (may be 0)?}
		notifyVersion:			LONGINT;								{ Set to 0 (future expansion)}
		notifyFlags:			LONGINT;								{ Set to 0 (future expansion)}
		notifyReserved:			LONGINT;								{ Set to 0 (future expansion)}
		notifyFuture:			LONGINT;								{ Set to 0 (future expansion)}
	END;
	DependentNotifyPtr = ^DependentNotifyRec;

	DMNotificationProcPtr = ProcPtr;  { PROCEDURE DMNotification(VAR theEvent: AppleEvent); }
	DMExtendedNotificationProcPtr = ProcPtr;  { PROCEDURE DMExtendedNotification(userData: UNIV Ptr; theMessage: INTEGER; notifyData: UNIV Ptr); }
	DMTableclothProcPtr = ProcPtr;  { FUNCTION DMTablecloth(refCon: UNIV Ptr; theMsg: TableclothMessagesType; theData: UNIV Ptr): OSErr; }
	DMListIteratorProcPtr = ProcPtr;  { PROCEDURE DMListIterator(userData: UNIV Ptr; itemIndex: DMListIndexType; listInfo: DMListEntryPtr); }
	DMNotificationUPP = UniversalProcPtr;
	DMExtendedNotificationUPP = UniversalProcPtr;
	DMTableclothUPP = UniversalProcPtr;
	DMListIteratorUPP = UniversalProcPtr;

CONST
	uppDMNotificationProcInfo = $000000C0; { PROCEDURE (4 byte param); }
	uppDMExtendedNotificationProcInfo = $00000EC0; { PROCEDURE (4 byte param, 2 byte param, 4 byte param); }
	uppDMTableclothProcInfo = $00000EE0; { FUNCTION (4 byte param, 2 byte param, 4 byte param): 2 byte result; }
	uppDMListIteratorProcInfo = $00000FC0; { PROCEDURE (4 byte param, 4 byte param, 4 byte param); }

FUNCTION NewDMNotificationProc(userRoutine: DMNotificationProcPtr): DMNotificationUPP;
	{$IFC NOT GENERATINGCFM }
	INLINE $2E9F;
	{$ENDC}

FUNCTION NewDMExtendedNotificationProc(userRoutine: DMExtendedNotificationProcPtr): DMExtendedNotificationUPP;
	{$IFC NOT GENERATINGCFM }
	INLINE $2E9F;
	{$ENDC}

FUNCTION NewDMTableclothProc(userRoutine: DMTableclothProcPtr): DMTableclothUPP;
	{$IFC NOT GENERATINGCFM }
	INLINE $2E9F;
	{$ENDC}

FUNCTION NewDMListIteratorProc(userRoutine: DMListIteratorProcPtr): DMListIteratorUPP;
	{$IFC NOT GENERATINGCFM }
	INLINE $2E9F;
	{$ENDC}

PROCEDURE CallDMNotificationProc(VAR theEvent: AppleEvent; userRoutine: DMNotificationUPP);
	{$IFC NOT GENERATINGCFM}
	INLINE $205F, $4E90;
	{$ENDC}

PROCEDURE CallDMExtendedNotificationProc(userData: UNIV Ptr; theMessage: INTEGER; notifyData: UNIV Ptr; userRoutine: DMExtendedNotificationUPP);
	{$IFC NOT GENERATINGCFM}
	INLINE $205F, $4E90;
	{$ENDC}

FUNCTION CallDMTableclothProc(refCon: UNIV Ptr; theMsg: TableclothMessagesType; theData: UNIV Ptr; userRoutine: DMTableclothUPP): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $205F, $4E90;
	{$ENDC}

PROCEDURE CallDMListIteratorProc(userData: UNIV Ptr; itemIndex: DMListIndexType; listInfo: DMListEntryPtr; userRoutine: DMListIteratorUPP);
	{$IFC NOT GENERATINGCFM}
	INLINE $205F, $4E90;
	{$ENDC}

TYPE
	TableclothInfoRec = RECORD
		tableclothInstance:		DMTableclothUPP;
		nextAnimateTick:		LONGINT;
		refCon:					Ptr;
		allDisplays:			BOOLEAN;
		filler:					ARRAY [0..2] OF BOOLEAN;
	END;
	TableclothInfoPtr = ^TableclothInfoRec;

{ Trap interfaces }

FUNCTION DMGetFirstScreenDevice(activeOnly: BOOLEAN): GDHandle;
	{$IFC NOT GENERATINGCFM}
	INLINE $7000, $ABEB;
	{$ENDC}
FUNCTION DMGetNextScreenDevice(theDevice: GDHandle; activeOnly: BOOLEAN): GDHandle;
	{$IFC NOT GENERATINGCFM}
	INLINE $7001, $ABEB;
	{$ENDC}
PROCEDURE DMDrawDesktopRect(VAR globalRect: Rect);
	{$IFC NOT GENERATINGCFM}
	INLINE $7002, $ABEB;
	{$ENDC}
PROCEDURE DMDrawDesktopRegion(globalRgn: RgnHandle);
	{$IFC NOT GENERATINGCFM}
	INLINE $7003, $ABEB;
	{$ENDC}
FUNCTION DMGetGDeviceTablecloth(displayID: DisplayIDType; tableclothInstance: TableclothInfoPtr): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0404, $ABEB;
	{$ENDC}
FUNCTION DMSetGDeviceTablecloth(displayID: DisplayIDType; tableclothInstance: TableclothInfoPtr): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0405, $ABEB;
	{$ENDC}
FUNCTION DMBeginConfigureDisplays(VAR displayState: Handle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0206, $ABEB;
	{$ENDC}
FUNCTION DMEndConfigureDisplays(displayState: Handle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0207, $ABEB;
	{$ENDC}
FUNCTION DMAddDisplay(newDevice: GDHandle; driver: INTEGER; mode: LONGINT; reserved: LONGINT; displayID: LONGINT; displayComponent: ComponentInstance; displayState: Handle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0D08, $ABEB;
	{$ENDC}
FUNCTION DMMoveDisplay(moveDevice: GDHandle; x: INTEGER; y: INTEGER; displayState: Handle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0609, $ABEB;
	{$ENDC}
FUNCTION DMDisableDisplay(disableDevice: GDHandle; displayState: Handle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $040A, $ABEB;
	{$ENDC}
FUNCTION DMEnableDisplay(enableDevice: GDHandle; displayState: Handle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $040B, $ABEB;
	{$ENDC}
FUNCTION DMRemoveDisplay(removeDevice: GDHandle; displayState: Handle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $040C, $ABEB;
	{$ENDC}
{ OBSOLETE ******************
pascal OSErr DMGetComponentAnimateTicks(DMTableclothUPP animationComponent,unsigned long *goodDelay,unsigned long *maxDelay)
    = (0x303C,0x060D,0xABEB)		( ; fix pascal headers

pascal OSErr DMSetComponentAnimateTicks(DMTableclothUPP animationComponent,unsigned long goodDelay,unsigned long maxDelay)
    = (0x303C,0x060E,0xABEB)		( ; fix pascal headers

pascal OSErr DMGetNextAnimateTime(unsigned long *nextAnimateTime)
    = (0x303C,0x020F,0xABEB)		( ; fix pascal headers
************************** }
FUNCTION DMSetMainDisplay(newMainDevice: GDHandle; displayState: Handle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0410, $ABEB;
	{$ENDC}
FUNCTION DMSetDisplayMode(theDevice: GDHandle; mode: LONGINT; VAR depthMode: LONGINT; reserved: LONGINT; displayState: Handle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0A11, $ABEB;
	{$ENDC}
FUNCTION DMCheckDisplayMode(theDevice: GDHandle; mode: LONGINT; depthMode: LONGINT; VAR switchFlags: LONGINT; reserved: LONGINT; VAR modeOk: BOOLEAN): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0C12, $ABEB;
	{$ENDC}
FUNCTION DMGetDeskRegion(VAR desktopRegion: RgnHandle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0213, $ABEB;
	{$ENDC}
FUNCTION DMRegisterNotifyProc(notificationProc: DMNotificationUPP; whichPSN: ProcessSerialNumberPtr): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0414, $ABEB;
	{$ENDC}
FUNCTION DMRemoveNotifyProc(notificationProc: DMNotificationUPP; whichPSN: ProcessSerialNumberPtr): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0415, $ABEB;
	{$ENDC}
FUNCTION DMQDIsMirroringCapable(VAR qdIsMirroringCapable: BOOLEAN): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0216, $ABEB;
	{$ENDC}
FUNCTION DMCanMirrorNow(VAR canMirrorNow: BOOLEAN): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0217, $ABEB;
	{$ENDC}
FUNCTION DMIsMirroringOn(VAR isMirroringOn: BOOLEAN): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0218, $ABEB;
	{$ENDC}
FUNCTION DMMirrorDevices(gD1: GDHandle; gD2: GDHandle; displayState: Handle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0619, $ABEB;
	{$ENDC}
FUNCTION DMUnmirrorDevice(gDevice: GDHandle; displayState: Handle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $041A, $ABEB;
	{$ENDC}
FUNCTION DMGetNextMirroredDevice(gDevice: GDHandle; VAR mirroredDevice: GDHandle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $041B, $ABEB;
	{$ENDC}
FUNCTION DMBlockMirroring: OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $701C, $ABEB;
	{$ENDC}
FUNCTION DMUnblockMirroring: OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $701D, $ABEB;
	{$ENDC}
FUNCTION DMGetDisplayMgrA5World(VAR dmA5: LONGINT): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $021E, $ABEB;
	{$ENDC}
FUNCTION DMGetDisplayIDByGDevice(displayDevice: GDHandle; VAR displayID: DisplayIDType; failToMain: BOOLEAN): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $051F, $ABEB;
	{$ENDC}
FUNCTION DMGetGDeviceByDisplayID(displayID: DisplayIDType; VAR displayDevice: GDHandle; failToMain: BOOLEAN): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0520, $ABEB;
	{$ENDC}
FUNCTION DMSetDisplayComponent(theDevice: GDHandle; displayComponent: ComponentInstance): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0421, $ABEB;
	{$ENDC}
FUNCTION DMGetDisplayComponent(theDevice: GDHandle; VAR displayComponent: ComponentInstance): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0422, $ABEB;
	{$ENDC}
FUNCTION DMNewDisplay(VAR newDevice: GDHandle; driverRefNum: INTEGER; mode: LONGINT; reserved: LONGINT; displayID: DisplayIDType; displayComponent: ComponentInstance; displayState: Handle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0D23, $ABEB;
	{$ENDC}
FUNCTION DMDisposeDisplay(disposeDevice: GDHandle; displayState: Handle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0424, $ABEB;
	{$ENDC}
FUNCTION DMResolveDisplayComponents: OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $7025, $ABEB;
	{$ENDC}
FUNCTION DMRegisterExtendedNotifyProc(notifyProc: DMExtendedNotificationUPP; notifyUserData: UNIV Ptr; nofifyOnFlags: INTEGER; whichPSN: ProcessSerialNumberPtr): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $07EF, $ABEB;
	{$ENDC}
FUNCTION DMRemoveExtendedNotifyProc(notifyProc: DMExtendedNotificationUPP; notifyUserData: UNIV Ptr; whichPSN: ProcessSerialNumberPtr; removeFlags: INTEGER): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0026, $ABEB;
	{$ENDC}
FUNCTION DMNewPanelList(displayID: DisplayIDType; panelType: ResType; minimumFidelity: DMFidelityType; panelListFlags: LONGINT; reserved: LONGINT; VAR thePanelCount: DMListIndexType; VAR thePanelList: DMListType): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0027, $ABEB;
	{$ENDC}
FUNCTION DMNewEngineList(displayID: DisplayIDType; engineType: ResType; minimumFidelity: DMFidelityType; engineListFlags: LONGINT; reserved: LONGINT; VAR engineCount: DMListIndexType; VAR engineList: DMListType): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0028, $ABEB;
	{$ENDC}
FUNCTION DMNewDeviceList(deviceType: ResType; deviceListFlags: LONGINT; reserved: LONGINT; VAR deviceCount: DMListIndexType; VAR deviceList: DMListType): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0029, $ABEB;
	{$ENDC}
FUNCTION DMNewDevicePortList(subType: ResType; portListFlags: LONGINT; reserved: LONGINT; VAR devicePortCount: DMListIndexType; VAR theDevicePortList: DMListType): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $002A, $ABEB;
	{$ENDC}
FUNCTION DMGetIndexedItemFromList(panelList: DMListType; itemIndex: DMListIndexType; reserved: LONGINT; listIterator: DMListIteratorUPP; userData: UNIV Ptr): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $002B, $ABEB;
	{$ENDC}
FUNCTION DMDisposeList(panelList: DMListType): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $002C, $ABEB;
	{$ENDC}
FUNCTION DMGetNameByDisplayID(displayID: DisplayIDType; VAR name: Str255): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $042D, $ABEB;
	{$ENDC}
FUNCTION DMNewDisplayIDByPortComponent(thePortComponent: Component; portKind: ResType; reserved: LONGINT; VAR newID: DisplayIDType): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $082E, $ABEB;
	{$ENDC}
FUNCTION DMGetPortComponentByPortID(thePortID: DisplayIDType; VAR thePortComponent: Component; VAR theDesciption: ComponentDescription; VAR thePortKind: ResType): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $082F, $ABEB;
	{$ENDC}
FUNCTION DMSendDependentNotification(notifyType: ResType; notifyClass: ResType; displayID: DisplayIDType; portID: LONGINT; notifyComponent: ComponentInstance): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $002D, $ABEB;
	{$ENDC}
FUNCTION DMDisposePortComponent(thePortComponent: Component): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0231, $ABEB;
	{$ENDC}
{pascal OSErr DMGetPortIDByDeviceComponent(Component deviceComponent, DisplayIDType* displayID)}
{    = (0x303C,0x0032,0xABEB);}
FUNCTION DMGetDisplayIDByDeviceComponent(deviceComponent: Component; VAR displayID: DisplayIDType): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $002E, $ABEB;
	{$ENDC}
{
	Required calls in components:
	

	GeneralDeviceCalls
		Return information specific to all devices

	OSErr		CountDevicePorts(unsigned long portCount, ResType deviceType);
	OSErr		GetPortInfo(unsigned long portNumber,PortInfoRec* portInfo);
					PortInfo gives information for multiported devices (such as Telecaster).
	OSErr		CountPortEngineComponents(unsigned long portNumber,unsigned long* engineCount);
	OSErr		GetPortEngineComponentInfo(unsigned long portNumber,unsigned long engineCount, DevicePortInfoRec* componentInfo);


	Video Engine Components
		Return information specific to video devices

	OSErr		CheckTiming
					Give the device a chance to okay or modify device settings
					especially useful for overridding the "needsConfirm" bit.
	OSErr		GetVideoInfo
					It would be nice to be able to get direct info about screen size
					dot pitch etc.  This obviously needs to be fleshed out.
	OSErr		SetWiggleDevice(Boolean wiggleDevice);
	OSErr		GetWiggleDevice(Boolean* isWiggling);
					Returns an error if device is not capable of wiggling

	Sound Engine Components
	
	OSErr		SetWiggleDevice(Boolean wiggleDevice);
	OSErr		GetWiggleDevice(Boolean* isWiggling);
					Returns an error if device is not capable of wiggling

	HI Component Calls
	
	OSErr		TargetDevice(DisplayID displayID);
	We could also define a standard notify message and call that when we had an update issue (saving on components having to register for notifies)
			That would by us not having to handle an extended remove notification that handles "you data" specific removes.
}

{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := DisplaysIncludes}

{$ENDC} {__DISPLAYS__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
